<?php

namespace Entities;

use Doctrine\ORM\EntityRepository;

/**
 * AffaireRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class AffaireRepository extends EntityRepository {

    public function __construct($em, \Doctrine\ORM\Mapping\ClassMetadata $class) {
        parent::__construct($em, $class);
//		error_reporting(E_ALL);
//		ini_set("display_errors", true);
    }

    public function search($code, $recherche = null, $user, $agence = null, $statuts = null, $affaires_archivees = false) {

        $em = $this->getEntityManager();
        $top = "";
        if ($recherche == null && $user->role > 5 && !$agence)
            return;

        $q = "SELECT a.id, a.code, a.libelle, a.nom_mo, a.adresse_id, a.id_qp_contrat, a.id_g_affaire, a.statut_affaire FROM affaire a
              LEFT JOIN sinistre s ON s.affaire_id = a.id
              LEFT JOIN adresse ad ON a.adresse_id = ad.id
              LEFT JOIN statut av1 ON av1.id = s.av1_id
              LEFT JOIN statut do ON do.id = s.do_id
              LEFT JOIN statut jud ON jud.id = s.judiciaire_id
              LEFT JOIN statut autre ON autre.id = s.amiable_id
              LEFT JOIN statut rp ON rp.id = s.rp_id
              ";
        $where = "WHERE";

        if ($code) {
            $q .= $where . " a.code like '%$code%'";
            $where = " AND";
        }
        if ($recherche) {
            $q .= $where . "( a.libelle like '%$recherche%' 
                             OR a.code like '%$recherche%'
                             OR ad.rue1 like '%$recherche%'
                             OR ad.rue2 like '%$recherche%'
                             OR ad.rue3 like '%$recherche%'
                             or ad.commune like '%$recherche%'
                             or ad.cp like '%$recherche%'
                             or s.ref_asqua like '%$recherche%'
                             OR do.ref_dossier_expert like '%$recherche%'
                             OR av1.ref_dossier_expert like '%$recherche%'
                             OR jud.ref_dossier_expert like '%$recherche%'
                             OR autre.ref_dossier_expert like '%$recherche%'
                             OR do.ref_dossier_expert_compagnie like '%$recherche%'
                             OR av1.ref_dossier_expert_compagnie like '%$recherche%'
                             OR jud.ref_dossier_expert_compagnie like '%$recherche%'
                             OR autre.ref_dossier_expert_compagnie like '%$recherche%'
                             OR do.ref_dossier_avocat like '%$recherche%'
                             OR av1.ref_dossier_avocat like '%$recherche%'
                             OR jud.ref_dossier_avocat like '%$recherche%'
                             OR autre.ref_dossier_avocat like '%$recherche%') ";
            $where = "AND";
        }

        if ($agence && !is_array($agence)) {
            $q .= $where . " a.id_agence = $agence ";
            $where = "AND";
        }
        
        if ($agence && is_array($agence)) {
            $reduced = implode(",", $agence);
            $q .= $where . " a.id_agence IN ($reduced)";
            $where = "AND";
        }

        switch ($user->role) {
            case 1:
                $q .= $where . " a.id_ca = $user->id_utilisateur ";
                $where = "AND";
                break;
            case 2:
            case 3:
            case 4:
                $exceptionEnDur = "";
                if ($user->id_utilisateur == 496 || $user->id_utilisateur == 929) {
                    $exceptionEnDur = "OR a.id_agence IN (49, 165, 83) ";
                }

                $rcrRepo = $em->getRepository('Entities\Rcr');
                $qb = $rcrRepo->createQueryBuilder('r');
                $agencespp = $qb->where($qb->expr()->eq('r.id_rca', $user->id_utilisateur))->orWhere($qb->expr()->eq('r.id_aca', $user->id_utilisateur))->getQuery()->getResult();

                foreach ($agencespp as $elem) {
                    if (!in_array($elem->getId_agence(), $user->agence))
                        $user->agence[] = $elem->getId_agence();
                }

                $agences = implode(",", $user->agence);
                $q .= $where . " (a.id_agence IN ($agences) OR a.id_service = $user->id_service OR a.id_ca = $user->id_utilisateur $exceptionEnDur) ";
                $where = "AND";

                break;
            case 5:
                $rcr = $em->getRepository('Entities\Rcr')->findBy(array('id_rcr' => $user->id_utilisateur));
                $agences = "";
                foreach ($rcr as $r) {
                    $agences .= $r->getId_agence();
                    if ($r != end($rcr)) {
                        $agences .= ",";
                    }
                }

                $regions = "";
                if ($user->region) {
                    foreach ($user->region as $region) {
                        $regions .= $region;
                        if ($region != end($user->region))
                            $regions .= ",";
                    }
                }
                $parenthese = "(";
                if ($agences && !$agence) {
                    $q .= $where . "$parenthese a.id_agence IN ($agences)";
                    $where = "OR";
                    $parenthese = "";
                }
                if ($regions && !empty($regions) && !$agence) {
                    $q .= " $where $parenthese a.id_region IN ($regions)";
                    $where = "OR";
                    $parenthese = "";
                }

                if (!$agence) {
                    $q .= " $where $parenthese a.id_ca = $user->id_utilisateur OR a.rcr = $user->id_utilisateur ";
                    $where = "AND";
                    $parenthese = "";
                }
                if ($parenthese == "")
                    $q .= ")";
                break;
            case 6:
                if (is_array($user->agence)) {
                    $nagence = implode(",", $user->agence);
                } else {
                    $nagence = $user->agence;
                }
                $q .= $where . " a.id_agence IN ($nagence)";
                $where = "AND";
                break;
        }

        if ($statuts != null) {
            $q .= " $where (";
            $w = "";
            if (@$statuts["do"]) {
                $q .= " do.id is not null ";
                $w = "OR";
            }
            if (@$statuts["av1"]) {
                $q .= "$w av1.id is not null ";
                $w = "OR";
            }
            if (@$statuts["jud"]) {
                $q .= "$w jud.id is not null ";
                $w = "OR";
            }
            if (@$statuts["autre"]) {
                $q .= "$w autre.id is not null ";
                $w = "OR";
            }
            if (@$statuts["rp"]) {
                $q .= "$w rp.id is not null ";
            }
            $q .= ") ";

            $where = "AND";
        }

        if ($affaires_archivees) {
            $q .= " $where (a.statut_affaire IN(0,1))";
            $where = "AND";
        } else {
            $q .= " $where (a.statut_affaire = 0 or a.statut_affaire is NULL)";
            $where = "AND";
        }

        echo "<!--$q-->";

        $em = $this->getEntityManager();
        $rsm = new \Doctrine\ORM\Query\ResultSetMappingBuilder($em);
        $rsm->addRootEntityFromClassMetadata('Entities\Affaire', 'a');
        $query = $em->createNativeQuery($q, $rsm);

        return $query->getResult();
    }

}
